// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/networkconnectivity/v1/hub.proto
// Original file comments:
// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fnetworkconnectivity_2fv1_2fhub_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fnetworkconnectivity_2fv1_2fhub_2eproto__INCLUDED

#include "google/cloud/networkconnectivity/v1/hub.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace networkconnectivity {
namespace v1 {

// Network Connectivity Center is a hub-and-spoke abstraction for network
// connectivity management in Google Cloud. It reduces operational complexity
// through a simple, centralized connectivity management model.
class HubService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.networkconnectivity.v1.HubService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists the Network Connectivity Center hubs associated with a given project.
    virtual ::grpc::Status ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>> AsyncListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>>(AsyncListHubsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>> PrepareAsyncListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>>(PrepareAsyncListHubsRaw(context, request, cq));
    }
    // Gets details about a Network Connectivity Center hub.
    virtual ::grpc::Status GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::google::cloud::networkconnectivity::v1::Hub* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>> AsyncGetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>>(AsyncGetHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>> PrepareAsyncGetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>>(PrepareAsyncGetHubRaw(context, request, cq));
    }
    // Creates a new Network Connectivity Center hub in the specified project.
    virtual ::grpc::Status CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateHubRaw(context, request, cq));
    }
    // Updates the description and/or labels of a Network Connectivity Center
    // hub.
    virtual ::grpc::Status UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateHubRaw(context, request, cq));
    }
    // Deletes a Network Connectivity Center hub.
    virtual ::grpc::Status DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteHubRaw(context, request, cq));
    }
    // Lists the Network Connectivity Center spokes in a specified project and
    // location.
    virtual ::grpc::Status ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>> AsyncListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>>(AsyncListSpokesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>> PrepareAsyncListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>>(PrepareAsyncListSpokesRaw(context, request, cq));
    }
    // Gets details about a Network Connectivity Center spoke.
    virtual ::grpc::Status GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::google::cloud::networkconnectivity::v1::Spoke* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>> AsyncGetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>>(AsyncGetSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>> PrepareAsyncGetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>>(PrepareAsyncGetSpokeRaw(context, request, cq));
    }
    // Creates a Network Connectivity Center spoke.
    virtual ::grpc::Status CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateSpokeRaw(context, request, cq));
    }
    // Updates the parameters of a Network Connectivity Center spoke.
    virtual ::grpc::Status UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateSpokeRaw(context, request, cq));
    }
    // Deletes a Network Connectivity Center spoke.
    virtual ::grpc::Status DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteSpokeRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists the Network Connectivity Center hubs associated with a given project.
      virtual void ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details about a Network Connectivity Center hub.
      virtual void GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Network Connectivity Center hub in the specified project.
      virtual void CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the description and/or labels of a Network Connectivity Center
      // hub.
      virtual void UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a Network Connectivity Center hub.
      virtual void DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the Network Connectivity Center spokes in a specified project and
      // location.
      virtual void ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details about a Network Connectivity Center spoke.
      virtual void GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a Network Connectivity Center spoke.
      virtual void CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a Network Connectivity Center spoke.
      virtual void UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a Network Connectivity Center spoke.
      virtual void DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>* AsyncListHubsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>* PrepareAsyncListHubsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>* AsyncGetHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>* PrepareAsyncGetHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* AsyncListSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* PrepareAsyncListSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>* AsyncGetSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>* PrepareAsyncGetSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>> AsyncListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>>(AsyncListHubsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>> PrepareAsyncListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>>(PrepareAsyncListHubsRaw(context, request, cq));
    }
    ::grpc::Status GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::google::cloud::networkconnectivity::v1::Hub* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>> AsyncGetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>>(AsyncGetHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>> PrepareAsyncGetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>>(PrepareAsyncGetHubRaw(context, request, cq));
    }
    ::grpc::Status CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateHubRaw(context, request, cq));
    }
    ::grpc::Status UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateHubRaw(context, request, cq));
    }
    ::grpc::Status DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteHubRaw(context, request, cq));
    }
    ::grpc::Status ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>> AsyncListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>>(AsyncListSpokesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>> PrepareAsyncListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>>(PrepareAsyncListSpokesRaw(context, request, cq));
    }
    ::grpc::Status GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::google::cloud::networkconnectivity::v1::Spoke* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>> AsyncGetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>>(AsyncGetSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>> PrepareAsyncGetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>>(PrepareAsyncGetSpokeRaw(context, request, cq));
    }
    ::grpc::Status CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateSpokeRaw(context, request, cq));
    }
    ::grpc::Status UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateSpokeRaw(context, request, cq));
    }
    ::grpc::Status DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteSpokeRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response, std::function<void(::grpc::Status)>) override;
      void GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response, std::function<void(::grpc::Status)>) override;
      void GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>* AsyncListHubsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>* PrepareAsyncListHubsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>* AsyncGetHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>* PrepareAsyncGetHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* AsyncListSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* PrepareAsyncListSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>* AsyncGetSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>* PrepareAsyncGetSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListHubs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetHub_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateHub_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateHub_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteHub_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSpokes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSpoke_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSpoke_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSpoke_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSpoke_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists the Network Connectivity Center hubs associated with a given project.
    virtual ::grpc::Status ListHubs(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response);
    // Gets details about a Network Connectivity Center hub.
    virtual ::grpc::Status GetHub(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response);
    // Creates a new Network Connectivity Center hub in the specified project.
    virtual ::grpc::Status CreateHub(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response);
    // Updates the description and/or labels of a Network Connectivity Center
    // hub.
    virtual ::grpc::Status UpdateHub(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response);
    // Deletes a Network Connectivity Center hub.
    virtual ::grpc::Status DeleteHub(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response);
    // Lists the Network Connectivity Center spokes in a specified project and
    // location.
    virtual ::grpc::Status ListSpokes(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response);
    // Gets details about a Network Connectivity Center spoke.
    virtual ::grpc::Status GetSpoke(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response);
    // Creates a Network Connectivity Center spoke.
    virtual ::grpc::Status CreateSpoke(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a Network Connectivity Center spoke.
    virtual ::grpc::Status UpdateSpoke(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response);
    // Deletes a Network Connectivity Center spoke.
    virtual ::grpc::Status DeleteSpoke(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListHubs() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHubs(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::ListHubsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetHub() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetHub(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::Hub>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateHub() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateHub(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateHub() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateHub(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteHub() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteHub(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSpokes() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSpokes(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSpoke() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSpoke(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::Spoke>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSpoke(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSpoke(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSpoke(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListHubs<WithAsyncMethod_GetHub<WithAsyncMethod_CreateHub<WithAsyncMethod_UpdateHub<WithAsyncMethod_DeleteHub<WithAsyncMethod_ListSpokes<WithAsyncMethod_GetSpoke<WithAsyncMethod_CreateSpoke<WithAsyncMethod_UpdateSpoke<WithAsyncMethod_DeleteSpoke<Service > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListHubs() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListHubsRequest, ::google::cloud::networkconnectivity::v1::ListHubsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response) { return this->ListHubs(context, request, response); }));}
    void SetMessageAllocatorFor_ListHubs(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::ListHubsRequest, ::google::cloud::networkconnectivity::v1::ListHubsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListHubsRequest, ::google::cloud::networkconnectivity::v1::ListHubsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHubs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetHub() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetHubRequest, ::google::cloud::networkconnectivity::v1::Hub>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response) { return this->GetHub(context, request, response); }));}
    void SetMessageAllocatorFor_GetHub(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::GetHubRequest, ::google::cloud::networkconnectivity::v1::Hub>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetHubRequest, ::google::cloud::networkconnectivity::v1::Hub>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetHub(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateHub() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::CreateHubRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response) { return this->CreateHub(context, request, response); }));}
    void SetMessageAllocatorFor_CreateHub(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::CreateHubRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::CreateHubRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateHub(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateHub() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::UpdateHubRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response) { return this->UpdateHub(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateHub(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::UpdateHubRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::UpdateHubRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateHub(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteHub() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::DeleteHubRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response) { return this->DeleteHub(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteHub(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::DeleteHubRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::DeleteHubRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteHub(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSpokes() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListSpokesRequest, ::google::cloud::networkconnectivity::v1::ListSpokesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response) { return this->ListSpokes(context, request, response); }));}
    void SetMessageAllocatorFor_ListSpokes(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::ListSpokesRequest, ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListSpokesRequest, ::google::cloud::networkconnectivity::v1::ListSpokesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSpokes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSpoke() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetSpokeRequest, ::google::cloud::networkconnectivity::v1::Spoke>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response) { return this->GetSpoke(context, request, response); }));}
    void SetMessageAllocatorFor_GetSpoke(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::GetSpokeRequest, ::google::cloud::networkconnectivity::v1::Spoke>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetSpokeRequest, ::google::cloud::networkconnectivity::v1::Spoke>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::CreateSpokeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response) { return this->CreateSpoke(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSpoke(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::CreateSpokeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::CreateSpokeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response) { return this->UpdateSpoke(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSpoke(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response) { return this->DeleteSpoke(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSpoke(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListHubs<WithCallbackMethod_GetHub<WithCallbackMethod_CreateHub<WithCallbackMethod_UpdateHub<WithCallbackMethod_DeleteHub<WithCallbackMethod_ListSpokes<WithCallbackMethod_GetSpoke<WithCallbackMethod_CreateSpoke<WithCallbackMethod_UpdateSpoke<WithCallbackMethod_DeleteSpoke<Service > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListHubs() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetHub() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateHub() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateHub() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteHub() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSpokes() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSpoke() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListHubs() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHubs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetHub() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetHub(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateHub() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateHub(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateHub() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateHub(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteHub() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteHub(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSpokes() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSpokes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSpoke() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSpoke(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSpoke(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSpoke(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSpoke(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListHubs() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListHubs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHubs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetHub() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetHub(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetHub(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateHub() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateHub(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateHub(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateHub() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateHub(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateHub(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteHub() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteHub(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteHub(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSpokes() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSpokes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSpokes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSpoke() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSpoke(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSpoke(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSpoke(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSpoke(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListHubs() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::ListHubsRequest, ::google::cloud::networkconnectivity::v1::ListHubsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::ListHubsRequest, ::google::cloud::networkconnectivity::v1::ListHubsResponse>* streamer) {
                       return this->StreamedListHubs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListHubs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::ListHubsRequest,::google::cloud::networkconnectivity::v1::ListHubsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetHub() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::GetHubRequest, ::google::cloud::networkconnectivity::v1::Hub>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::GetHubRequest, ::google::cloud::networkconnectivity::v1::Hub>* streamer) {
                       return this->StreamedGetHub(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetHub(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::GetHubRequest,::google::cloud::networkconnectivity::v1::Hub>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateHub() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::CreateHubRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::CreateHubRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateHub(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateHub(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::CreateHubRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateHub() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::UpdateHubRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::UpdateHubRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateHub(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateHub(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::UpdateHubRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteHub() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::DeleteHubRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::DeleteHubRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteHub(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteHub(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::DeleteHubRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSpokes() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::ListSpokesRequest, ::google::cloud::networkconnectivity::v1::ListSpokesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::ListSpokesRequest, ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* streamer) {
                       return this->StreamedListSpokes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSpokes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::ListSpokesRequest,::google::cloud::networkconnectivity::v1::ListSpokesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSpoke() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::GetSpokeRequest, ::google::cloud::networkconnectivity::v1::Spoke>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::GetSpokeRequest, ::google::cloud::networkconnectivity::v1::Spoke>* streamer) {
                       return this->StreamedGetSpoke(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSpoke(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::GetSpokeRequest,::google::cloud::networkconnectivity::v1::Spoke>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::CreateSpokeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::CreateSpokeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateSpoke(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSpoke(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::CreateSpokeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateSpoke(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSpoke(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteSpoke(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSpoke(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListHubs<WithStreamedUnaryMethod_GetHub<WithStreamedUnaryMethod_CreateHub<WithStreamedUnaryMethod_UpdateHub<WithStreamedUnaryMethod_DeleteHub<WithStreamedUnaryMethod_ListSpokes<WithStreamedUnaryMethod_GetSpoke<WithStreamedUnaryMethod_CreateSpoke<WithStreamedUnaryMethod_UpdateSpoke<WithStreamedUnaryMethod_DeleteSpoke<Service > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListHubs<WithStreamedUnaryMethod_GetHub<WithStreamedUnaryMethod_CreateHub<WithStreamedUnaryMethod_UpdateHub<WithStreamedUnaryMethod_DeleteHub<WithStreamedUnaryMethod_ListSpokes<WithStreamedUnaryMethod_GetSpoke<WithStreamedUnaryMethod_CreateSpoke<WithStreamedUnaryMethod_UpdateSpoke<WithStreamedUnaryMethod_DeleteSpoke<Service > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace networkconnectivity
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fnetworkconnectivity_2fv1_2fhub_2eproto__INCLUDED
